<?php
/*
 * ----------------------------------------------------------------------------
 * Download.php                                                      04/21/2003
 * This script will allow a web user to download a specified file from a
 * database entry.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2003 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

require_once('va-functions.inc.php');       // A VADV-PHP script.
require_once('va-loginauth.inc.php');       // Include login authentication.
require_once('va-database.inc.php');        // Include database functions.
require_once('va-main.inc.php');            // Include main configuration.

// Check the passed parameters. This script will look directly at the database
// to determine the filename instead of passing the filename and path directly.
if (isset($_POST['t'])) {                   // Set the passed variables.
    $t = htmlspecialchars($_POST['t']);
} else {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}

if (isset($_POST['d'])) {                   // Set the passed variables.
    $d = intval($_POST['d']);
} else {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}

if (isset($_POST['m'])) {                   // Set the passed variables.
    $m = intval($_POST['m']);
} else {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}

// Check to see if this page was referred by another page, and check to see where
// that page was at.
if ((!isset($_SERVER['HTTP_REFERER'])) ||
    (!strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']))) {
    die('<br /><h4>You are not allowed to access this script from an outside source.<br />Press the BACK button on your browser.</h4>');
}

if ($t == 'email') {
    $db = SetEmailInfo($USER['userno']);
} else {
    $db = GetDbInfo($t, $d);                // Retrieve the database information.
}

$msgInfo = GetMessageInfo($db, $m);         // Retrieve the message information.
if ($msgInfo['attfilename'] != '') {
    if ($msgInfo['attfilepath'] != '') {    // If a local attachment.
        $filepath = $msgInfo['attfilepath'];
        $pos = strrpos($filepath, "\\");
        $filepath = substr($filepath, 0, $pos);
    } else {
        $filepath = $db['filepath'];
    }
    if ($filepath != '') {
        if ($CONFIG['filehost']) {
            $file = ConvertDir($CONFIG['filehost'], $filepath) . '/' . $msgInfo['attfilename'];
        } else {
            $file = $filepath . '/' . $msgInfo['attfilename'];
        }
    } else {
        $file = $VA_SYSPATHS['sysop'] . '/' . $msgInfo['attfilename'];
    }
} else {
    die('<br /><h4>File is missing. Press the BACK button on your browser.</h4>');
}

if (!is_file($file)) die('<br /><h4>File is missing. Press the BACK button on your browser.</h4>');

if ($t != 'email') {                        // Check to see if the user has enough credits.
    $credits = $USER['credits'] - (intval(filesize($file) / 1024) * $VA_MAIN['credperdlk']);
    if ($credits < 0) die('<br /><h4>You do not have enough credits to download this file!<br />To gain more credits, try uploading new files or posting in the message area.<br />Press the BACK button on your browser.</h4>');
}

if (!SendFile($file)) die('<br /><h4>An error occurred during the transfer. Press the BACK button on your browser.</h4>');


/**
* Download.php :: SendFile()
*
* This function will send the specified file to the user using the fpassthru()
* function.
*
*/
function SendFile($file) {
    $status   = FALSE;                      // Set the status to default to false.
    $filename = basename($file);            // Get the filename.

    if ((!is_file($file)) || (connection_status() != 0)) return FALSE;
    header("Cache-Control: ");
    header("Pragma: ");
    header("Content-type: application/octet-stream");
    header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
    header("Content-transfer-encoding: binary");
    header("Content-length: " . (filesize($file)));

    $fp = fopen($file, 'rb');               // Open the file to send.
    $status = fpassthru($fp);               // Send the file.

    return $status;                         // Return the status.
}

?>
