<?php
/*
 * ----------------------------------------------------------------------------
 * Forum-DispDb.php                                                  04/21/2003
 * This script will display the databases of the specified topic.
 * The variable $t is passed to the script to set the topic number.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2003 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

require_once('va-functions.inc.php');       // A VADV-PHP script.
require_once('va-loginauth.inc.php');       // Login authentication.
require_once('va-database.inc.php');        // Include database functions.
require_once('va-userfile.inc.php');        // Include userfile functions.
require_once('layout_forum.inc.php');       // Webpage header and footer.

if (isset($_GET['t'])) {                    // Set the passed variables.
    $t = intval($_GET['t']);
} else {
    $t = 1;
}

if ($t < 1) $t = 1;

$topic = GetTopicInfo($t, 'M');             // Get the topic information.
// If this is an invalid section, display an error message.
if (!$topic) die('<br /><h4>Invalid topic. Please press the BACK button on your browser.</h4>');
// Determine if the user has access to this section.
if ($topic['dbno'] == 0) die('<br /><h4>You do not have access to this section. Please press the BACK button on your browser.</h4>');

ForumHeader();                              // Display the webpage header.
?>
<table border="0" cellspacing="0" cellpadding="0" width="750" style="border-collapse: collapse" bordercolor="#111111">
    <tr>
        <td class="msgBack" align="left">
            <a class="msgBack" href="forum-disptopics.php">Back to Forum Topics</a></td>
        <td class="msgBack" align="right">
            <a class="msgBack" href="index.php">Return to Home Page</a></td>
    </tr>
</table>
<table border="1" width="750" cellspacing="0" cellpadding="2" bordercolor="#666666" style="border-collapse: collapse">
    <tr>
        <td colspan="5" bgcolor="#416DBF" height="33">
            <table border="0" style="border-collapse: collapse" cellpadding="0" cellspacing="0" width="100%" height="100%">
                <tr>
                    <td align="left" width="100%">
                        <span class="msgTitle">&nbsp;&nbsp;<?php print htmlspecialchars($topic['desc']); ?></span></td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td width="30" height="15" bgcolor="#000080"></td>
        <td width="425" height="15" bgcolor="#000080" align="left">
            <span class="msgHeader">&nbsp;Forum&nbsp;</span></td>
        <td width="50" height="15" bgcolor="#000080" align="center">
            <span class="msgHeader">&nbsp;Posts&nbsp;</span></td>
        <td width="195" height="15" bgcolor="#000080" align="center">
            <span class="msgHeader">&nbsp;Last Post&nbsp;</span></td>
        <td width="100" height="15" bgcolor="#000080" align="center">
            <span class="msgHeader">&nbsp;Moderator&nbsp;</span></td>
    </tr>
<?php
// Set the fileString variable.
$file = $VA_SYSPATHS['main'] . '/database.cfg';
if (!is_file($file)) die('<br /><h4>Requested configuration file is missing. Please press the BACK button on your browser.</h4>');
$fileString = ReadCfgFile($file);       // Read the file.

$flag = 1;
for ($x = 1; $flag <= $topic['dbno']; $x++) {
    $db = FindDBInfo($t, $x, $fileString);  // Retrieve the database information.
    $last = GetLastPostInfo($db);           // Retrieve the last post information of the database.
    $dateTime = ConvertDateTime($last['date'], $last['time']);

    $moderator = '';
    if ($db['moderator'] != 0) {            // If there is a moderator, get the handle.
        $user = GetUser($db['moderator']);
        $moderator = htmlspecialchars($user['handle']);
    }
    
    $msgno = $db['msgno'];                  // Get the number of messages in the database.
    if (!$msgno) $msgno = 0;                // If there is no file, then there is no messages.

    if (DbAccess($db) != 0) {
        $flag++;
?>
    <tr>
        <td width="30" height="30" bgcolor="#E2E2E2" align="center"><img border="0" <?php if (GetMessagePointer($db, $USER['userno']) < $db['msgno']) {print "src=\"images/folder-new.gif\" alt=\"Database Folder (New Messages!)\"";} else {print "src=\"images/folder.gif\" alt=\"Database Folder\"";} ?> width="13" height="11"></td>
        <td width="425" height="30" align="left">
            <span class="heading">&nbsp;<?php if ($msgno > 0) print "<a href=\"forum-dispmsg.php?t=" . $t . "&d=" . $x . "\">"; print htmlspecialchars($db['desc']); if ($msgno > 0) print "</a>"; ?>&nbsp;</span></td>
        <td width="50" height="30" bgcolor="#E2E2E2" align="center">
            <span class="msgBody">&nbsp;<?php print $msgno; ?>&nbsp;</span></td>
        <?php if ($msgno > 0) { ?>
        <td width="195" height="30" align="center">
            <span class="body">&nbsp;<?php print $dateTime['date']; ?></span><span class="msgTime">&nbsp;<?php print $dateTime['time']; ?></span><?php if ($dateTime['time'] != 0) {$from = $last['fromhandle']; $pos = strpos($from, '@'); if ($pos > 0) {$from = substr($from, 0, $pos); $pos = strpos($from, ' '); if ($pos > 0) $from = substr($from, 1, $pos - 2);} $from = htmlspecialchars($from); print "<br /><span class=\"body\">by </span><span class=\"boldBody\">" . $from . "&nbsp;</span>";}?></td>
        <?php } else if (($USER['userno'] != 0) && ($USER['securitylevel'] >= $db['minwritesl'])) { ?>
        <form action="post-message.php" name="post" method="POST">
            <td width="195" height="30" align="center">
                <input type="hidden" name="referer" value="<?php print GetCurrentURL(); ?>">
                <input type="hidden" name="t" value="<?php print $t; ?>">
                <input type="hidden" name="d" value="<?php print $db['dbno']; ?>">
                <input type="hidden" name="reply" value="0">
                <input type="image" name="submit" src="images/post.gif" border="0" alt="Post a New Message" width="80" height="25">
            </td>
        </form>
        <?php } else { ?>
        <td width="195" height="30" align="center"></td>
        <?php } ?>
        <td width="100" height="30" bgcolor="#E2E2E2" align="center">
            <span class="body"><?php print $moderator; ?></span></td>
    </tr>
<?php
    }
}
?>
    <tr>
        <td bgcolor="#416DBF" align="center" colspan="5" height="25">&nbsp;</td>
    </tr>
</table>
<table border="0" cellspacing="0" cellpadding="0" width="750" style="border-collapse: collapse" bordercolor="#111111">
    <tr>
        <td class="msgBack" align="left">
            <a class="msgBack" href="forum-disptopics.php">Back to Forum Topics</a></td>
        <td class="msgBack" align="right">
            <a class="msgBack" href="index.php">Return to Home Page</a></td>
    </tr>
</table>
<?php
$totalTime = round(ProgramTime() - $startTime, 4);

ForumFooter();                              // Display the webpage footer.
?>
