<?php
/*
 * ----------------------------------------------------------------------------
 * Forum-ViewMsg.php                                                 04/21/2003
 * This script will display the selected message to the user.
 * The variable $t is passed to the script to set the topic number.
 * The variable $d is passed to the script to set the database number.
 * The variable $m is passed to the script to set the message number.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2003 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */
 
require_once('va-functions.inc.php');       // A VADV-PHP script.
require_once('va-loginauth.inc.php');       // Login authentication.
require_once('va-database.inc.php');        // Include database functions.
require_once('layout_forum.inc.php');       // Webpage header and footer.

if (isset($_GET['t'])) {                    // Set the passed variables.
    $t = intval($_GET['t']);
} else {
    $t = 1;
}

if (isset($_GET['d'])) {                    // Set the passed variables.
    $d = intval($_GET['d']);
} else {
    $d = 1;
}

if ($t < 1) $t = 1;
if ($d < 1) $d = 1;

$db = GetDbInfo($t, $d);                    // Retrieve the database information.
$msgno = $db['msgno'];                      // Retrieve the number of messages.
if ($msgno == 0) die('<br /><h4>Invalid message. Please press the BACK button on your browser.</h4>');

if (isset($_GET['m'])) {                    // Set the passed variables.
    $m = intval($_GET['m']);
} else {
    $m = $msgno;
}
if ($m > $msgno) $m = $msgno;

$msgInfo = GetMessageInfo($db, $m);         // Get the message information.

// Determine if the user has access to this section.
if (DbAccess($db) == 0) die('<br /><h4>You do not have access to this section. Please press the BACK button on your browser.</h4>');

$topic = GetTopicInfo($t, 'M');             // Retrieve the topic information.
// If this is an invalid section, display an error message.
if ($topic == '') die('<br /><h4>Invalid topic. Please press the BACK button on your browser.</h4>');

// Determine if the message is deleted and give proper access.
if (($msgInfo['deleted'] == 1) && (($USER['securitylevel'] != 255) && (($db['moderator'] != $USER['userno']) || ($db['moderator'] == 0)))) die('<br /><h4>This message has been deleted. Please press the BACK button on your browser.</h4>');

// Check for delete message flag.
if (isset($_GET['delete'])) {
    if ($_GET['delete'] == 1) {
        // If an attached file, then delete it. Non-reversible!
        if ($msgInfo['attfilename'] != '') {
            if ($CONFIG['filehost'] != '') {
                $file = ConvertDir($CONFIG['hostname'], $db['filepath']) . '/' . $msgInfo['attfilename'];
            } else {
                $file = $db['filepath'] . '/' . $msgInfo['attfilename'];
            }
            if ($msgInfo['attfilepath'] == '') unlink($file);
            $msgInfo['attfilesize'] = 0;
            $msgInfo['attfilename'] = '';
            $msgInfo['attfilepath'] = '';
        }
        $msgInfo['deleted'] = 1;
        WriteMessageInfo($db, $m, $msgInfo);
        RedirectUser('forum-dispmsg.php?t=' . $t . '&d=' . $d);
    } else if ($_GET['delete'] == 0) {
        $msgInfo['deleted'] = 0;
        WriteMessageInfo($db, $m, $msgInfo);
    }
}

ForumHeader();                              // Display the webpage header.
?>
<table border="0" cellspacing="0" cellpadding="0" width="750" style="border-collapse: collapse" bordercolor="#111111">
    <tr>
        <td class="msgBack" align="left">
<?php
if ($m > 1) {
    $num = $m - 1;
    print "<a class=\"msgBack\" href=\"forum-viewmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Previous Message</a> |\n";
}

if ($m < $msgno) {
    $num = $m + 1;
    print "<a class=\"msgBack\" href=\"forum-viewmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Next Message</a> |\n";
}
print "<a class=\"msgBack\" href=\"forum-dispmsg.php?t=" . $t . "&d=" . $d . "\">Back to " . htmlspecialchars($db['desc']) . "</a>\n";
?>
        </td>
        <td class="msgBack" align="right">
            <a class="msgBack" href="index.php">Return to Home Page</a></td>
    </tr>
</table>
<table border="1" width="750" cellspacing="0" cellpadding="2" bordercolor="#666666" style="border-collapse: collapse">
    <tr>
        <td colspan="5" bgcolor="#416DBF" height="33" width="750">
            <table border="0" style="border-collapse: collapse" cellpadding="0" cellspacing="0" width="100%" height="100%">
                <tr>
                    <td align="left" width="100%">
                        <span class="msgTitle">&nbsp;&nbsp;<?php print htmlspecialchars($db['desc']); ?></span></td>
                    <?php if (($USER['userno'] != 0) && ($USER['securitylevel'] >= $db['minwritesl'])) { ?>
                    <form action="post-message.php" name="post" method="POST">
                        <td align="right">
                            <input type="hidden" name="referer" value="<?php print GetCurrentURL(); ?>">
                            <input type="hidden" name="t" value="<?php print $t; ?>">
                            <input type="hidden" name="d" value="<?php print $d; ?>">
                            <input type="hidden" name="reply" value="0">
                            <input type="image" name="submit" src="images/post.gif" border="0" alt="Post a New Message" width="80" height="25">
                        </td>
                    </form>
                    <form action="post-message.php" name="reply" method="POST">
                        <td align="right">
                            <input type="hidden" name="referer" value="<?php print GetCurrentURL(); ?>">
                            <input type="hidden" name="t" value="<?php print $t; ?>">
                            <input type="hidden" name="d" value="<?php print $d; ?>">
                            <input type="hidden" name="reply" value="<?php print $m; ?>">
                            <input type="image" name="submit" src="images/reply.gif" border="0" alt="Reply to this Message" width="51" height="25">
                        </td>
                    </form>
                    <?php } ?>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td width="30" height="15" bgcolor="#000080"></td>
        <td width="100" height="15" bgcolor="#000080" align="left">
            <span class="msgHeader">&nbsp;From&nbsp;</span></td>
        <td width="100" height="15" bgcolor="#000080" align="left">
            <span class="msgHeader">&nbsp;To&nbsp;</span></td>
        <td width="370" height="15" bgcolor="#000080" align="left">
            <span class="msgHeader">&nbsp;Subject&nbsp;</span></td>
        <td width="150" height="15" bgcolor="#000080" align="center">
            <span class="msgHeader">&nbsp;Date/Time&nbsp;</span></td>
    </tr>
<?php
$dateTime = ConvertDateTime($msgInfo['date'], $msgInfo['time']);
// Check for any files.
if ($msgInfo['attfilename'] != '') {
    if ($db['filepath'] != '') {
        if ($CONFIG['filehost'] != '') {
            $file = ConvertDir($CONFIG['hostname'], $db['filepath']) . '/' . $msgInfo['attfilename'];
        } else {
            $file = $db['filepath'] . '/' . $msgInfo['attfilename'];
        }
    } else {
        $file = $VA_SYSPATHS['sysop'] . '/' . $msgInfo['attfilename'];
    }
} else {
    $file = '';
}

if ($file != '') {
    if (!is_file($file)) {
        $filesize = '0 bytes';
    } else {
        $filesize = filesize($file);
        if ($filesize >= 1024000) {
            $filesize = round($filesize / 1048576, 1) . 'MB';
        } elseif ($filesize >= 1024) {
            $filesize = intval($filesize / 1024) . 'KB';
        } else {
            $filesize = $filesize . ' bytes';
        }
    }
}

if ($msgInfo['fromhandle'] == '') {
    $from = 'Unknown';
} else {
    $from = $msgInfo['fromhandle'];
    $pos = strpos($from, '@');                      // Check for email address.
    if ($pos > 0) {
        $from = substr($from, 0, $pos);
        $pos = strpos($from, ' ');                  // Check for nntp post.
        if ($pos > 0) $from = substr($from, 1, $pos - 2);
    }
    $from = htmlspecialchars($from);
}

$to = $msgInfo['tohandle'];
$pos = strpos($to, '@');                        // Check for email address.
if ($pos > 0) {
    $to = substr($to, 0, $pos);
    $pos = strpos($to, ' ');                    // Check for nntp post.
    if ($pos > 0) $to = substr($to, 1, $pos - 2);
}
$to = htmlspecialchars($to);

if ($msgInfo['subject'] == '') {
    $subject = 'No Subject';
} else {
    $subject = htmlspecialchars($msgInfo['subject']);
}

$pos = strpos($to, '@');
if ($pos > 0) $to = substr($to, 0, $pos);
?>
    <tr>
        <td width="30" height="30" bgcolor="#E2E2E2" align="center">
            <img border="0" <?php if ($msgInfo['deleted'] == 0) {print "src=\"images/message.gif\" alt=\"Message\"";} else {print "src=\"images/message-deleted.gif\" alt=\"Message Marked for Deletion\"";} ?> width="11" height="11"><?php if ($msgInfo['attfilename'] != '') print "<img border=\"0\" src=\"images/paperclip.gif\" alt=\"Attached File\" width=\"11\" height=\"11\">"; ?></td>
        <td width="100" height="30" align="left">
            <span class="boldBody">&nbsp;<?php print $from; ?>&nbsp;</span></td>
        <td width="100" height="30" bgcolor="#E2E2E2" align="left">
            <span class="body">&nbsp;<?php print $to; ?>&nbsp;</span></td>
        <td width="370" height="30" align="left">
            <span class="heading">&nbsp;<?php print $subject; ?>&nbsp;</span></td>
        <td width="150" height="30" bgcolor="#E2E2E2" align="center">
            <span class="body">&nbsp;<?php print $dateTime['date']; ?></span><span class="msgTime">&nbsp;<?php print $dateTime['time']; ?>&nbsp;</span></td>
    </tr>
<?php
$message = HTMLEncode(StripANSICodes(StripHeartColors(GetMessage($db, $m))));   // Get the message to display.
?>
    <tr>
        <td width="750" align="left" colspan="5" valign="top">
<?php
// Deletion option.
if (($USER['securitylevel'] == 255) || (($db['moderator'] == $USER['userno']) && ($db['moderator'] > 0))) {
    if ($msgInfo['deleted'] == 1) {
        print "<span class=\"msgBack\">(Message marked for deletion)</span><span class=\"body\"> - </span>\n";
        print "<span class=\"msgBack\"><a href=\"forum-viewmsg.php?t=" . $t . "&d=" . $d . "&m=" . $m . "&delete=0\">UnMark this Message for Deletion</a></span>\n";
    } else {
        print "<span class=\"msgBack\"><a href=\"forum-viewmsg.php?t=" . $t . "&d=" . $d . "&m=" . $m . "&delete=1\">Mark this Message for Deletion</a></span>\n";
    }
}

// If there is an attached file, then display its link.
if ($file != '') {
?>
    <form name="download" action="download.php" method="POST">
        <input type="hidden" name="t" value="<?php print $t; ?>">
        <input type="hidden" name="d" value="<?php print $d; ?>">
        <input type="hidden" name="m" value="<?php print $m; ?>">
        <input type="image" value="Download" src="images/download.gif" alt="Download <?php print $msgInfo['attfilename']; ?>" width="80" height="25" align="absmiddle">
        <span class="filename">&nbsp;Attached file: <?php print $msgInfo['attfilename']; ?></span><span class="filesize"> (<?php print $filesize; ?>)</span>
    </form>
<?php
} else {
    print '<br />';
}
?>
            <pre><?php print $message; ?></pre>
        </td>
    <tr>
        <td bgcolor="#416DBF" align="center" colspan="5" height="25" width="748">&nbsp;</td>
    </tr>
</table>
<?php
// Setup the previous/next links.
?>
<table border="0" cellspacing="0" cellpadding="0" width="750" style="border-collapse: collapse" bordercolor="#111111">
    <tr>
        <td class="msgBack" align="left">
<?php
if ($m > 1) {
    $num = $m - 1;
    print "<a class=\"msgBack\" href=\"forum-viewmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Previous Message</a> |\n";
}

if ($m < $msgno) {
    $num = $m + 1;
    print "<a class=\"msgBack\" href=\"forum-viewmsg.php?t=" . $t . "&d=" . $d . "&m=" . $num . "\">Next Message</a> |\n";
}
print "<a class=\"msgBack\" href=\"forum-dispmsg.php?t=" . $t . "&d=" . $d . "\">Back to " . htmlspecialchars($db['desc']) . "</a>\n";
?>
        </td>
        <td class="msgBack" align="right">
            <a class="msgBack" href="index.php">Return to Home Page</a></td>
    </tr>
</table>
<?php
// Update message pointer if needed.
if (GetMessagePointer($db, $USER['userno']) < $m) {
    WriteMessagePointer($db, $USER['userno'], $m);
}

$totalTime = round(ProgramTime() - $startTime, 4);

ForumFooter();                              // Display the webpage footer.

?>
