<?php
/*
 * ----------------------------------------------------------------------------
 * Common.inc.php                                                    04/21/2003
 * This script contains common functions to the VADV-PHP project that may be
 * useful when writing web pages.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2003 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

require_once('va-functions.inc.php');       // A VADV-PHP script.
require_once('va-loginauth.inc.php');

/**
* Common.inc.php :: LoginBox()
*
* This function will display the login box. If the user is not logged in, then
* he will be presented with a form to login. If the user is currently logged in,
* then he will be presented with a logoff button.
*
*/
function LoginBox() {
    global $USER;
    
    if (!$_SESSION['auth']) {
        if ($_SESSION['error']) {
            // Destroy the session information.
            session_unset();
            session_destroy();
?>
            <p class="infoBarBody" align="center"><span class="boldInfoBar">Invalid username or password!</span></p>
<?php
        }
?>
        <script language="javaScript">
        <!--
        function validate(form) {
            if ((form.username.value.length == 0) || (form.password.value.length == 0)) {
                alert("Please enter a username and password.")
                form.username.focus()
                return false
            }
        }
        //-->
        </script>
        <form name="login" method="POST" action="login.php" onsubmit="return validate(login)">
            <input type="hidden" name="referer" value="<?php print GetCurrentURL(); ?>">
            <?php if (isset($_GET['url'])) print "<input type=\"hidden\" name=\"url\" value=\"" . $_GET['url'] . "\">"; ?>
            <div align="center">
                <center>
                    <table width="100" cellspacing="0" border="0" cellpadding="2">
                        <tr>
                            <td width="50%">
                                <p class="infoBarBody" align="left">Username:</p>
                            </td>
                            <td width="50%">
                                <p align="left"><input type="text" name="username" size="12" maxlength="40"></p>
                            </td>
                        </tr>
                        <tr>
                            <td width="50%">
                                <p class="infoBarBody" align="left">Password:</p>
                            </td>
                            <td width="50%">
                                <p align="left"><input type="password" name="password" size="12" maxlength="8"></p>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2" width="100%">
                                <p class="infoBarBody" align="center"><input type="image" name="submit" src="images/login.gif" border="0" alt="Login!" width="54" height="25"></p>
                                <p class="infoBarBody" align="center"><input type="checkbox" name="remember" value="1"> Remember Me<br />(expires in a week)</p>
                            </td>
                        </tr>
                    </table>
                </center>
            </div>
        </form>
<?php
    } else {
?>
        <form method="POST" action="login.php">
            <input type="hidden" name="logoff" value="logoff">
            <input type="hidden" name="referer" value="<?php print GetCurrentURL(); ?>">
            <p align="center" class="infoBarBody"><span class="boldInfoBar">You are logged in as: <?php print $USER['handle']; ?></span> (#<?php print $USER['userno']; ?>)</p>
            <p align="center"><input type="image" name="submit" src="images/logoff.gif" border="0" alt="Logoff!" width="62" height="25"></p>
        </form>
<?php
    }
}

?>
