<?php
/*
 * ----------------------------------------------------------------------------
 * Login.php                                                         04/21/2003
 * This script is called when a user trys to login. If successful, then the
 * user's session data is updated.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2003 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */
 
require_once('va-functions.inc.php');
require_once('va-userfile.inc.php');

if (!isset($_POST['referer'])) die('<br /><h4>An error occurred. Please press the BACK button on your browser.</h4>');

// Save the default values.
$_SESSION['userno']   = base64_encode(0);
$_SESSION['username'] = base64_encode('');
$_SESSION['password'] = base64_encode('');
$_SESSION['login']    = FALSE;

if (isset($_POST['logoff'])) {
    setcookie('vadvphp', '', time() - 86400, '/', '', 0);
    session_unset();
    session_destroy();
    RedirectUser($_POST['referer']);
}

if (isset($_POST['username'])) {
    if ($_POST['username'] == '') {
        RedirectUser($_POST['referer']);
    } else {
        $username = trim(htmlspecialchars($_POST['username']));
        if (strlen($username) > 40) $username = substr($username, 0, 40);
    }
} else {
    RedirectUser($_POST['referer']);
}

if (isset($_POST['password'])) {
    if ($_POST['password'] == '') {
        RedirectUser($_POST['referer']);
    } else {
        $password = strtoupper(trim(htmlspecialchars($_POST['password'])));
        if (strlen($password) > 8) $password = substr($password, 0, 8);
        $password = md5($password);
    }
} else {
    RedirectUser($_POST['referer']);
}

$userno = FindHandle($username);
if ($userno == 0) $userno = FindRealName($username);
if ($userno == 0) RedirectUser($_POST['referer']);

// Set the log temp variable.
$_SESSION['login'] = TRUE;

// Save the user's information.
$_SESSION['userno']   = base64_encode($userno);
$_SESSION['username'] = base64_encode($username);
$_SESSION['password'] = base64_encode($password);

// If the remember checkbox is enabled, then set cookie.
if (isset($_POST['remember'])) {
    if ($_POST['remember'] == 1) {
        $cookie = $_SESSION['userno'] . ' , ' . $_SESSION['username'] . ' , ' . $_SESSION['password'];
        setcookie('vadvphp', $cookie, time() + 604800, '/', '', 0);
    }
}

if (isset($_POST['url'])) {
    RedirectUser($_POST['referer'] . '?url=' . urlencode($_POST['url']));
} else {
    RedirectUser($_POST['referer']);
}

?>
